import sys
import os

import gsdl2 as pygame
from gsdl2.locals import *

from constants import *

SCALE  = 1.0
screen = None
surface = None
resolution = None
screen_rect = None
surface_rect = None

def init(scale=2.0, caption="NES Game", res=NESRES):
    """Initialise the SDL display -> return None
    """
    
    global SCALE, screen, surface, resolution, screen_rect, surface_rect
    resolution = res
    SCALE = scale
    
    os.environ["SDL_VIDEO_CENTERED"] = "1"
    pygame.init()
    
    screen = pygame.display.set_mode((
        int(resolution[0]*SCALE), 
        int(resolution[1]*SCALE)))
    screen_rect = screen.get_rect()
    surface = pygame.Surface(NESRES)
    surface_rect = surface.get_rect()
    pygame.display.set_caption(caption)
    update()
    
    # pygame.mouse.set_visible(0)

def update():
    """Update and draw the scene -> return None
    """
    
    global surface, resolution
    # SDL 1.x code...
    # surface = pygame.transform.scale(surface,
    #     (int(resolution[0]*SCALE), int(resolution[1]*SCALE)))
    # screen.blit(surface, (0, 0))
    # surface = pygame.transform.scale(surface, resolution)

    if SCALE == 1.0:
        screen.blit(surface, (0, 0))
    else:
        screen.blit_scaled(surface, screen_rect, surface_rect)

    pygame.display.flip()

def get_surface():
    """Get the surface to draw to -> return pygame.Surface
    """
    
    return surface
